/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Boton_h
#define Boton_h

#include "defines.h"
#include "Widget.h"
#include "Texto.h"

// Valores por defecto para los botones
#define DF_COLORTEXTO       0x000001
#define DF_FLAGSBOTON       0
#define DF_FUENTEBOTON      ARIAL12

/**
 * Clase Boton heredada de Widget
 * Controla los botones que se veran en las ventanas o en la pantalla
 * @see Ventana::Ventana, Widget::Widget
 */
class Boton : public Widget {

  public:
    // Constructor a partir de un fichero de imagen
    Boton(CUADRO** cuadroPadre, char *ficheroImagen, int x, int y);
    // ## A hacer: Comprobar que puede tener texto si tiene imagen

    // Constructor indicando tamao
    Boton(CUADRO** cuadroPadre, Texto* titulo,
          int x, int y, int ancho, int alto);

    // Destructor del boton
    virtual ~Boton();

    // Detecta el raton sobre el boton
    DWORD detectarRaton();

    // Dibuja el boton
    void dibujar();

  public:
    // Texto que contiene el boton
    Texto *texto;          // ## A hacer: Convertir a vector de C++
};
#endif
