/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Juego_h
#define Juego_h

#include "Programa.h"
#include "Records.h"
#include "Mapa.h"
#include "Personaje.h"
#include "Caja.h"

#define JUEGO_NUEVO     0
#define JUEGO_CONTINUAR 1

// Clase Juego heredada de Programa
class Juego : public Programa {

 public:
    // Constructor de la clase
    Juego();

    // Destructor de la clase
    virtual ~Juego();

    // Comprueba la entrada en el juego por teclado y raton
    void  comprobarEntrada();

    // Comprueba el estado de la partida
    void  comprobarEstado();

    // Actualiza la pantalla de juego
    void  actualizarPantalla();

    // Prepara el nivel actual
    void  prepararNivel();

    // Pasa de nivel
    void  pasarNivel();

    // Comprueba un password que se solicita al jugador
    int   comprobarPassword();

    // Bucle principal del juego
    int   bucle(int continuar);

    int   terminar();

    void  bucleSinNiveles();

    //Caja* obtenerCaja(int x, int y);

 public:
    Records* records;
    Mapa* mapa;
    Personaje*  personaje;
    Caja**      caja;
    int nCajas;

    int nivelActual;
    int tiempo;
    int pasos;
    int puntos;
    int reintentos;
    void* imagenPrueba;
    tiempo_t inicio;

};
#endif
