/*
	Sokonux - 1.0.3
  Copyright (C) 2007  Daniel Ponsoda Montiel

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef Records_h
#define Records_h

#include "Programa.h"

#define FICHERO_RECORDS "nfo/records.bin"



/**
 * Clase Records heredada de Programa
 * Se encarga de administrar y mostrar los records.
 */
class Records : public Programa {

  public:
    // Constructor y destructor
    Records();
    virtual ~Records();

    // Actualiza la pantalla de records
    void actualizarPantalla();

    // Sale de los records
    int terminar();

    // Carga el fichero de records desde disco
    void cargar();

    // Guarda los records en disco
    void guardar();

    // Crea records predeterminados cuando no se pueden cargar
    void crearPredeterminados();

    // Comprueba un nuevo record
    void comprobar(int puntos);

    // Bucle principal de la pantalla de records
    int bucle();

  public:
    // Flag para ver los records automaticamente desde la pantalla menu
    int verAuto;

    // Informacion de los records (Hasta 10 entradas)
    // Estructura de una entrada de record
    struct IRECORD{
      char nombre[11];
      int puntos;
    }iRecord[10];

};
#endif
